const createSagaFunc = (mainName, actionParams) => {
  const paramList = actionParams.split(',');
  return `function* get${mainName.replace(/^./, function(str){ return str.toUpperCase(); })}(${paramList.map((p, i) => i === 0 ? p : ` ${p}`)}) {
  const jsonStr = JSON.stringify({ ${paramList.map((p, i) => i === 0 ? p : ` ${p}`)} });
  const result = yield call(request, url.${mainName.toUpperCase()}, 'POST', jsonStr, true);
  if (result !== 'invalid') {
    if (result.status) {
      yield put(actions.set${mainName.replace(/^./, function(str){ return str.toUpperCase(); })}(result.data));
    } else {
      yield put(actions.setToast(true, result.message, 'error'));
    }
  } else {
    yield put(actions.setToast(true, 'Could not establish a connection with the server!', 'warning'));
  }
}
`;
};

const createSagaWatcher = (mainName, actionParams) => {
  const paramList = actionParams.split(',');
  return `
function* get${mainName.replace(/^./, function(str){ return str.toUpperCase(); })}Watcher() {
  while (true) {
    const action = yield take(constants.GET_${mainName.toUpperCase()});
    yield call(get${mainName.replace(/^./, function(str){ return str.toUpperCase(); })}, ${paramList.map((p, i) => i === 0 ? `action.${p}` : ` action.${p}`)});
  }
}`;
};

const createRootSaga = (mainName) => {
 return `    get${mainName.replace(/^./, function(str){ return str.toUpperCase(); })}Watcher(),`;
};

exports.createSagaFunc = createSagaFunc;
exports.createSagaWatcher = createSagaWatcher;
exports.createRootSaga = createRootSaga;
